#ifndef __COMMON_H__
#define __COMMON_H__

#include "resource.h"

#ifdef _WIN32
	#include "SDL/SDL.h"
	#define _WIN32_WINNT 0x400
	#include <windows.h>
	#include <process.h>
	#define getfreq(x) { QueryPerformanceFrequency(&dummytimer); x = dummytimer.QuadPart; }
	#define getclock(x) { QueryPerformanceCounter(&dummytimer); x = dummytimer.QuadPart; }
#else
	#include <SDL/SDL.h>
	#include <sys/time.h>
	#include <pthread.h>
	#define getfreq(x) x = 1000000
	#define getclock(x) {\
		gettimeofday(&timestr, NULL);\
		x = timestr.tv_sec * 1000000 + timestr.tv_usec;\
	}

	#define MB_OK 0
	#define MB_ICONERROR 2
	#define MB_ICONQUESTION 3
	#define MB_ICONINFORMATION 5
	#define MB_YESNO 1
	#define IDYES 4

	#define MAX_PATH 255
	#define WPARAM int
	#define DWORD uint64_t
	#define LPSTR char *
#endif
#endif
