/* MoarNES source - record.c

   This open-source software is (c)2010-2013 Mike Chambers, and is released
   under the terms of the GNU GPL v2 license.

   This file contains the code to save the NES frames to a sequence of BMP files.
   This isn't utilized in the release version of MoarNES. I use it sometimes
   to help create demo videos of the software.
*/

#include <stdio.h>
#include "stdint.h"

uint8_t bmpthing[54] = {
    0x42, 0x4D, 0x36, 0xF4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x36,
    0x4, 0x0, 0x0, 0x28, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0xF0,
    0x0, 0x0, 0x0, 0x1, 0x0, 0x8, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
    0xF0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
	0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 };

struct bmppal {
    uint8_t pblue;
    uint8_t pgreen;
    uint8_t pred;
    uint8_t resvd;
} savepal[256];

extern const uint32_t paletteNES[66];
extern uint8_t outputNES[240][256];
extern uint8_t buf[2][8192];

uint32_t videoframe = 0;

FILE *wavout;
FILE *vidfile;

uint8_t dorecord = 0;
uint8_t recordpath[256];

void initrecord() {
	uint16_t i;
	uint8_t fname[256];

	sprintf(&fname[0], "%s\\moarnes.raw", &recordpath[0]);
	wavout = fopen(&fname[0], "wb");
	for (i=0; i<65; i++) {
		savepal[i].pred = (uint8_t)(paletteNES[i]>>16)&0xFF;
		savepal[i].pgreen = (uint8_t)(paletteNES[i]>>8)&0xFF;
		savepal[i].pblue = (uint8_t)paletteNES[i]&0xFF;
	}
}

void saveframe(uint16_t audsize) {
        char vidfilename[25]; int fnlen;
		uint16_t j;

        fwrite(&buf[1], audsize, 1, wavout);
        fnlen = sprintf(&vidfilename[0], "%s\\%u.bmp", &recordpath[0], videoframe++);
        vidfile = fopen(&vidfilename[0], "wb");
        fwrite(&bmpthing[0], 54, 1, vidfile);
        fwrite(&savepal[0], 1024, 1, vidfile);
        for (j=240; j>=1; j--) fwrite(&outputNES[j][0], 256, 1, vidfile);
        fclose(vidfile);
}
